/* Copyright (c) 1997-2009
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
   http://www.polymake.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
--------------------------------------------------------------------------------
   $Project: polymake $$Id: hash_iterators.h 9298 2009-09-02 23:10:56Z gawrilow $
*/

#ifndef _POLYMAKE_HASH_ITERATORS_H
#define _POLYMAKE_HASH_ITERATORS_H

#if __GNUC__==4 && __GNUC_MINOR__>=2
#  define PM_TR1_HashtableIterator      std::tr1::__detail::_Hashtable_iterator
#  define PM_TR1_HashtableConstIterator std::tr1::__detail::_Hashtable_const_iterator
#endif

namespace pm {

template <typename Value, bool __constant_iterators, bool __cache>
struct iterator_cross_const_helper< PM_TR1_HashtableIterator<Value,__constant_iterators,__cache>, true> {
   typedef PM_TR1_HashtableIterator<Value,__constant_iterators,__cache> iterator;
   typedef PM_TR1_HashtableConstIterator<Value,__constant_iterators,__cache> const_iterator;
};

template <typename Value, bool __constant_iterators, bool __cache>
struct iterator_cross_const_helper< PM_TR1_HashtableConstIterator<Value,__constant_iterators,__cache>, true> {
   typedef PM_TR1_HashtableIterator<Value,__constant_iterators,__cache> iterator;
   typedef PM_TR1_HashtableConstIterator<Value,__constant_iterators,__cache> const_iterator;
};

} // end namespace pm

#undef PM_TR1_HashtableIterator
#undef PM_TR1_HashtableConstIterator

#endif // _POLYMAKE_HASH_ITERATORS_H

// Local Variables:
// mode:C++
// End:
